unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, ScktComp, ExtCtrls;

type
  TForm1 = class(TForm)
    pripoj: TButton;
    tcp: TEdit;
    port: TEdit;
    odpoj: TButton;
    TcpClient: TTcpClient;
    info: TEdit;
    Timer: TTimer;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    posli: TButton;
    zavri: TButton;
    otevri: TButton;
    ui: TButton;
    procedure pripojClick(Sender: TObject);
    procedure odpojClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure posliClick(Sender: TObject);
    procedure otevriClick(Sender: TObject);
    procedure zavriClick(Sender: TObject);
    procedure uiClick(Sender: TObject);

  private
    { Private declarations }
  public
     front:array[1..10]of byte;
     ok:byte;
     vytahu:integer;
     vytahy:array[1..10]of record
                      patro:byte;
                      active:boolean;
                      otev:byte;
                     end;

  end;
var
  Form1: TForm1;
  zprava:string;

  informace:record
        vytahu:integer;
        patro:integer;
        cetujicich:integer;
        vzdal:integer;
       end;
Procedure cesta(cislo,kam:integer);
procedure stardat;
procedure dalai(i:integer);
implementation
{$R *.dfm}
procedure dalai(i:integer);
var ip:integer;
begin
  ip:=0;
  repeat
   ip:=ip+1;
  until ip=i;
end;
Procedure cesta(cislo,kam:integer);
var scislo,skam:string;
    s:string;
begin
   scislo:=inttostr(cislo);
   skam:=inttostr(kam);
   Form1.TcpClient.Sendln('close '+scislo+' CRLF');
   Form1.TcpClient.Sendln('floor '+scislo+' '+skam+' CRLF');
   Form1.TcpClient.Sendln('open '+scislo+' CRLF');
  {if cil>vytahy[cislo].patro then TcpClient.Sendln('speed '+cislo'-1')
      else TcpClient.Sendln('speed '+cislo'+1');
      active:=true;
      TcpClient.Sendln('start');}
end;


procedure TForm1.pripojClick(Sender: TObject);
begin
  if (port.Text<>'')and(tcp.Text<>'')then
     begin
        TcpClient.RemotePort:=port.Text;
        TcpClient.RemoteHost:=tcp.Text;
        TcpClient.Open;
               begin
                Form1.info.text:='Pipojen probhlo spne,nahrvm informace';
                stardat;
                pripoj.Enabled:=false;
                odpoj.Enabled:=true;
               end;
     end
      else info.Text:='Nen zadm port sevveru,nebo ip adresa';
end;

procedure TForm1.odpojClick(Sender: TObject);
begin
  TcpClient.Close;
  pripoj.Enabled:=true;
  odpoj.Enabled:=False;
  Form1.info.text:='Odpojeno od serveru';
end;

procedure stardat;
begin
     begin
     Form1.TcpClient.Sendln('shafts '+'CRLF');
     Form1.front[1]:=1;
     Form1.TcpClient.Sendln('levels '+'CRLF');
     Form1.front[2]:=2;
     Form1.TcpClient.Sendln('levelheight '+'CRLF');
     Form1.front[3]:=3;
     Form1.TcpClient.Sendln('maxonboard '+'CRLF');
     Form1.front[4]:=4;
     end;
end;

procedure TForm1.TimerTimer(Sender: TObject);
var s,p:string;
    i:integer;
begin
  s:=TcpClient.Receiveln;
  if s<>'' then zprava:=s;

{  for i:=0 to 16 do
   p:=p+info.Text[i];
  if s='cabincabinbutton' then
    begin
     info.Text:='Bylo stisknuto tlacitko ve vytahu '+zprava[19]+zprava[20]+'do patra '+zprava[21]+zprava[22];
     cesta(strtoint(zprava[19]+zprava[20]),strtoint(zprava[21]+zprava[22]));
    end;}

if s<>'' then case front[1] of
  1:begin
     s:=zprava[8]+zprava[9];
     informace.vytahu:=strtoint(s);
     Form1.vytahu:=informace.vytahu;
    end;
  2:begin
     s:=zprava[8]+zprava[9];
     informace.patro:=strtoint(s);
    end;
  3:begin
     s:=zprava[13]+zprava[14];
     informace.vzdal:=strtoint(s);
    end;
  4:begin
     s:=zprava[12]+zprava[13];
     informace.cetujicich:=strtoint(s);
    end;
  end;
  if ok=1 then
   begin
    for i:=0 to informace.vytahu do
      if vytahy[i].otev=0 then Form1.TcpClient.Sendln('open '+inttostr(i)+' CRLF');
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
ok:=0;
for i:=1 to 10 do Form1.vytahy[i].active:=false;
end;

procedure TForm1.posliClick(Sender: TObject);
begin
 cesta(strtoint(Edit1.text),strtoint(Edit2.Text));
end;

procedure TForm1.otevriClick(Sender: TObject);
begin
 TcpClient.Sendln('open '+Edit1.Text+'CRLF');
end;

procedure TForm1.zavriClick(Sender: TObject);
begin
  TcpClient.Sendln('close '+Edit1.Text+'CRLF');
end;

procedure TForm1.uiClick(Sender: TObject);
begin
if ok=1 then ok:=0
   else ok:=1;
end;


end.
